from pyloadl import *

"""

 rc = ll_control(control_op, host_list, user_list, job_list, class_list, 0)

 Return Values :

    rc         - Return code for operation

 Parameters :

    control_op - Represents the control operation to be performed
                 LL_CONTROL_RECYCLE, LL_CONTROL_RECONFIG,
                 LL_CONTROL_START,LL_CONTROL_STOP,
                 LL_CONTROL_DRAIN, LL_CONTROL_DRAIN_STARTD,
                 LL_CONTROL_DRAIN_SCHEDD, LL_CONTROL_PURGE_SCHEDD, 
                 LL_CONTROL_FLUSH, LL_CONTROL_SUSPEND,
                 LL_CONTROL_RESUME, LL_CONTROL_RESUME_STARTD, 
                 LL_CONTROL_RESUME_SCHEDD, LL_CONTROL_FAVOR_JOB,
                 LL_CONTROL_UNFAVOR_JOB, LL_CONTROL_FAVOR_USER,
                 LL_CONTROL_UNFAVOR_USER, LL_CONTROL_HOLD_USER,
                 LL_CONTROL_HOLD_SYSTEM, LL_CONTROL_HOLD_RELEASE,
                 LL_CONTROL_PRIO_ABS, LL_CONTROL_PRIO_ADJ,
                 LL_CONTROL_START_DRAINED

    host_list  - List of host names to perform operation on

    user_list  - List of user names to perform operation on

    job_list   - List of jobsteps to perform operation on
                 Uses the following formats: "host.jobid.stepid," "jobid.stepid,".
                 Where: host  : the name of the machine to which the job was submitted
                        jobid : the job ID assigned to the job by LoadLeveler
                        stepid: the job step ID assigned to a job step by LoadLeveler

    class_list - List of class names to perform operation on

 Note: The control function is used by the PyLoadL functions 
       llprio, llhold, llcancel, llfavorjob & llfavoruser
"""

jobs = ['shivling.97236.0']
hosts = []
users= []
jclass = []

rc = ll_control(LL_CONTROL_HOLD_SYSTEM, hosts, users, jobs, jclass, 0)

print "ll_control: returns %d\n" % rc
