
from pyloadl import *

"""

  rc, errObj = ll_modify(param, data, job_step)


  Return values :

     rc     - Return code for operation

     errObj - Provides a pointer to LL_element that points to an error object if this function fails.
              This can be passed onto the error function to output a error message. 

  Parameters :

     param  - Should be one of the following : 

              EXECUTION_FACTOR , numeric for execution factor
              CONSUMABLE_CPUS  , numeric for cpus
              CONSUMABLE_MEMORY, numeric for memory
              WCLIMIT_ADD_MIN  , numeric for wall clock limit
              JOB_CLASS        , string  for job class
              ACCOUNT_NO       , string  for account number

     data     - The new setting for the modify parameter

     job_step - Uses the following formats: "host.jobid.stepid," "jobid.stepid,".
                Where: host  : the name of the machine to which the job was submitted
                       jobid : the job ID assigned to the job by LoadLeveler 
                       stepid: the job step ID assigned to a job step by LoadLeveler 

""""

job_step = ['shivling.97242.0']

(rc, errObj) = ll_modify(JOB_CLASS,"small",job_step)
print "Return : %d\n" % rc
if (errObj):
  ll_error(errObj,1)
