import string

#
# This module allows us to see the API variables/values
#

LL_API_VERSION = 310
LL_JOB_PROC_VERSION = 9
LL_PROC_VERSION = 9
LL_JobVersionNum = 208
LL_VersionCheck = 2600
LL_CONTROL_VERSION = 310

FREE_SLOTS_LIMITED_BY_MAX_STARTERS = 1
MAXIMUM_SLOTS_LIMITED_BY_MAX_STARTERS = 2
FREE_SLOTS_LIMITED_BY_MAX_JOBS = 4

JOBS = 0 
MACHINES = 1
PERF = 2
CLUSTERS = 3 
WLMSTAT = 4 
MATRIX = 5
CLASSES = 6

SHARED = 0
NOT_SHARED = 1
SLICE_NOT_SHARED = 2

NO_HOLD = 0
HOLDTYPE_USER = 1
HOLDTYPE_SYSTEM = 2
HOLDTYPE_USERSYS = 3

SET_BATCH = 0
SET_INTERACTIVE = 1

BATCH_JOB = 0
INTERACTIVE_JOB = 1

BATCH_SESSION = 0
INTERACTIVE_SESSION = 1
INTERACTIVE_HOSTLIST_SESSION = 2

PREEMPT_STEP = 0
RESUME_STEP = 1
SYSTEM_PREEMPT_STEP = 2

QUERY_ALL = (1<<0)
QUERY_JOBID = (1<<1)
QUERY_STEPID = (1<<2)
QUERY_USER = (1<<3)
QUERY_GROUP = (1<<4)
QUERY_CLASS = (1<<5)
QUERY_HOST = (1<<6)
QUERY_PERF = (1<<7)
QUERY_STARTDATE = (1<<8)
QUERY_ENDDATE = (1<<9)
QUERY_PROCID = (1<<10)

LL_CHECKPOINT = (1<<0)
LL_SYSTEM_HOLD = (1<<1)
LL_USER_HOLD = (1<<2)
LL_RESTART = (1<<3)
LL_CPU_LIMIT_USER  = (1<<4)
LL_CORE_LIMIT_USER = (1<<5)
LL_DATA_LIMIT_USER = (1<<6)
LL_FILE_LIMIT_USER = (1<<7)
LL_RSS_LIMIT_USER = (1<<8)
LL_STACK_LIMIT_USER = (1<<9)
LL_NQS_STEP = (1<<10)
LL_STEP_PARALLEL = (1<<11)
LL_STEP_PVM3 = (1<<12)
LL_IMMEDIATE = (1<<13)
LL_NO_ALLOCATE = (1<<14)
LL_INTERACTIVE = (1<<15)
LL_API_ACTIVE = (1<<16)
LL_API_SYNC_START = (1<<17)
LL_NODE_USAGE_NOT_SHARED = (1<<18)
LL_RESTART_FROM_CKPT = (1<<19)
LL_CHECKPOINT_INTERVAL = (1<<20)
LL_RESTART_SAME_NODES = (1<<21)

LL_CONTROL_RECYCLE = 0
LL_CONTROL_RECONFIG = 1
LL_CONTROL_START = 2 
LL_CONTROL_STOP = 3
LL_CONTROL_DRAIN = 4 
LL_CONTROL_DRAIN_STARTD = 5
LL_CONTROL_DRAIN_SCHEDD = 6
LL_CONTROL_PURGE_SCHEDD = 7
LL_CONTROL_FLUSH = 8
LL_CONTROL_SUSPEND = 9
LL_CONTROL_RESUME = 10
LL_CONTROL_RESUME_STARTD = 11
LL_CONTROL_RESUME_SCHEDD = 12
LL_CONTROL_FAVOR_JOB = 13
LL_CONTROL_UNFAVOR_JOB = 14
LL_CONTROL_FAVOR_USER = 15
LL_CONTROL_UNFAVOR_USER = 16
LL_CONTROL_HOLD_USER = 17
LL_CONTROL_HOLD_SYSTEM = 18
LL_CONTROL_HOLD_RELEASE = 19
LL_CONTROL_PRIO_ABS = 20
LL_CONTROL_PRIO_ADJ = 21
LL_CONTROL_START_DRAINED = 22

STATE_IDLE = 0
STATE_PENDING = 1
STATE_STARTING = 2 
STATE_RUNNING = 3
STATE_COMPLETE_PENDING = 4 
STATE_REJECT_PENDING = 5
STATE_REMOVE_PENDING = 6
STATE_VACATE_PENDING = 7
STATE_COMPLETED = 8
STATE_REJECTED = 9
STATE_REMOVED = 10
STATE_VACATED = 11
STATE_CANCELED = 12
STATE_NOTRUN = 13
STATE_TERMINATED = 14
STATE_UNEXPANDED = 15
STATE_SUBMISSION_ERR = 16
STATE_HOLD = 17
STATE_DEFERRED = 18
STATE_NOTQUEUED = 19
STATE_PREEMPTED = 20
STATE_PREEMPT_PENDING = 21
STATE_RESUME_PENDING = 22

ALL_DATA = 0
STATUS_LINE = 1
Q_LINE = 2

LL_STARTD = 0
LL_SCHEDD = 1
LL_CM = 2
LL_MASTER = 3
LL_STARTER = 4
LL_HISTORY_FILE = 5

EXECUTION_FACTOR = 0
CONSUMABLE_CPUS = 1
CONSUMABLE_MEMORY = 2
WCLIMIT_ADD_MIN = 3
JOB_CLASS = 4
ACCOUNT_NO = 5

#
# Dictionary to identify LL_API_Specification types for the get_data routine
# If python had a switch this wouldn't be necessary but I would still need to
# create the variables
#

LLTYPE = { 'int':0, 'int_list':1, 'int64':2, 'time_t':3, 
                   'double':4, 'char':5, 'char_list':6, 'LL_element':7,
                   'bool':8, 'int64_t':9, 'uint64_t':10 }

#
# LLAPI contains the enum value for the definitions in LLAPI_ENUMS
#

LLAPI = {
 0:'char', 1:'int', 2:'char', 3:'int', 4:'LL_element', 5:'LL_element',
 200:'LL_element', 201:'LL_element', 202:'LL_element', 203:'char', 204:'int',
 205:'int', 206:'char', 207:'time_t', 208:'int',
 400:'int', 401:'LL_element', 402:'LL_element', 403:'int', 404:'LL_element',
 405:'LL_element', 406:'LL_element', 407:'LL_element', 408:'LL_element',
 409:'int', 410:'char', 411:'int', 412:'char', 413:'int', 414:'time_t',
 415:'char', 416:'char', 417:'int', 418:'char', 419:'char', 420:'char',
 421:'int', 422:'int', 423:'char', 424:'char', 425:'char', 426:'char',
 427:'int', 428:'char', 429:'int', 430:'int', 431:'char', 432:'time_t',
 433:'time_t', 434:'int', 435:'int', 436:'int', 437:'int', 438:'int',
 439:'int', 440:'int', 441:'int', 442:'int', 443:'int', 444:'int',
 445:'int', 446:'int', 447:'int', 448:'int', 449:'int', 450:'int',
 451:'int', 452:'char_list', 453:'int', 454:'char', 455:'LL_element',
 456:'LL_element', 457:'int', 458:'int', 459:'char', 460:'int',
 461:'int', 462:'char', 463:'int', 464:'int', 465:'int', 466:'int',
 467:'int', 468:'int', 469:'int64_t', 470:'int64_t', 471:'int64_t', 472:'int64_t',
 473:'int64_t', 474:'int64_t', 475:'int64_t', 476:'int64_t', 477:'int64_t', 478:'int64_t',
 479:'int64_t', 480:'int64_t', 481:'int64_t', 482:'int64_t', 483:'int64_t', 484:'int64_t',
 485:'int64_t', 486:'int64_t', 487:'int64_t', 488:'int64_t', 489:'int64_t', 490:'int64_t',
 491:'int64_t', 492:'int64_t', 493:'int64_t', 494:'int64_t', 495:'int64_t', 496:'int64_t',
 496:'int64_t', 497:'int64_t', 498:'int64_t', 499:'int64_t', 500:'int64_t', 501:'int64_t',
 502:'int64_t', 503:'int64_t', 504:'int64_t', 505:'int64_t', 506:'int64_t', 507:'int64_t',
 508:'int64_t', 509:'int64_t', 510:'int64_t', 511:'int64_t', 512:'int64_t', 513:'int64_t',
 514:'int64_t', 515:'int64_t', 516:'int64_t', 517:'int64_t', 518:'int', 519:'LL_element',
 520:'LL_element', 521:'int', 522:'bool', 523:'int', 524:'time_t', 525:'char',
 526:'time_t', 527:'time_t', 528:'int', 529:'int64_t', 530:'int', 531:'int64_t',
 532:'int', 533:'int', 534:'int', 535:'char', 536:'int', 537:'int', 538:'int',
 539:'time_t',540:'int',
 800:'char_list', 801:'char', 802:'char_list', 803:'int', 804:'int', 805:'char_list',
 806:'char_list', 807:'int', 808:'double', 809:'char', 810:'int', 811:'char', 
 812:'char', 813:'int_list', 814:'int', 815:'int', 816:'int', 817:'int', 818:'double',
 819:'char', 820:'int', 821:'char_list', 822:'time_t', 823:'int', 824:'int',
 825:'int', 826:'int', 827:'int', 828:'int', 829:'int', 830:'LL_element', 
 831:'LL_element', 832:'LL_element', 833:'LL_element', 834:'char_list', 
 835:'char_list', 836:'char', 837:'char', 838:'char', 839:'char',
 840:'char', 841:'int64_t', 842:'int64_t', 843:'int64_t', 844:'int64_t', 845:'int64_t',
 846:'int64_t', 847:'int64_t', 848:'int64_t', 849:'int64_t', 850:'int64_t', 851:'int64_t',
 1000:'int', 1001:'LL_element', 1002:'LL_element', 1003:'int', 1004:'int',
 1005:'char', 1006:'int',
 1200:'int',
 1400:'int', 1401:'LL_element', 1402:'LL_element', 1403:'char', 1404:'char',
 1405:'int', 1406:'LL_element', 1407:'LL_element',
 1600:'int', 1601:'LL_element', 1602:'LL_element', 1603:'LL_element',
 1604:'LL_element', 1605:'char', 1606:'int', 1607:'char',
 1800:'char', 1801:'char', 1802:'char', 1803:'int', 1804:'char',
 1806:'int', 1807:'char',
 1811:'int', 1812:'int', 1813:'char', 1814:'int', 1815:'char', 1816:'int',
 1817:'int', 1818:'int_list', 1819:'uint64_t', 1820:'uint64_t', 1821:'uint64_t',
 1822:'uint64_t', 1823:'char',
 2000:'int', 2001:'char', 2002:'int', 2003:'char',
 2200:'int', 2201:'int', 2202:'int', 2203:'int', 2204:'int', 2205:'int',
 2206:'int', 2207:'int', 2208:'int', 2209:'int', 2210:'int', 2211:'int',
 2212:'int', 2213:'int', 2214:'int', 2215:'int', 
 2400:'int', 2401:'int', 2402:'int', 2403:'int', 2404:'int', 2405:'int',
 2406:'int', 2407:'int', 2408:'int', 2409:'int', 2410:'int', 2411:'int',
 2412:'int', 2413:'int', 2414:'int', 2415:'int', 
 2600:'int', 
 2700:'int', 2701:'int', 
 2800:'LL_element', 2801:'LL_element', 2802:'char_list', 2803:'char_list',
 2804:'int', 2805:'int', 2806:'char_list', 2807:'int', 2808:'int', 2809:'char',
 2900:'char', 2901:'int', 2902:'int', 2903:'int64_t', 2904:'int64_t',
 3000:'char', 3001:'int', 3002:'int64_t',
 3100:'int64_t', 3101:'int', 3102:'int64_t', 3103:'int',
 3200:'int', 3201:'int', 3202:'int', 3203:'LL_element', 3204:'LL_element',
 3300:'char', 3301:'int', 3302:'int', 3303:'char_list',
 3400:'char', 3401:'double', 3402:'int', 3403:'LL_element', 3404:'LL_element',
 3500:'int', 3501:'LL_element', 3502:'LL_element', 3503:'int64_t', 3504:'int64_t',
 3505:'int64_t', 3506:'int64_t', 3507:'int64_t', 3508:'int64_t', 3509:'int64_t',
 3510:'int64_t', 3511:'int64_t', 3512:'int64_t', 3513:'int64_t', 3514:'int64_t',
 3515:'int64_t', 3516:'int64_t', 3517:'int64_t', 3518:'int64_t', 3519:'int64_t',
 3520:'int64_t', 3521:'int64_t', 3522:'int64_t', 3523:'int64_t', 3524:'int64_t',
 3525:'int64_t', 3526:'int64_t', 3527:'int64_t', 3528:'int64_t', 3529:'int64_t',
 3530:'int64_t', 3531:'int64_t', 3532:'int64_t', 3533:'int64_t', 3534:'int64_t',
 3600:'int', 3601:'char', 3602:'int', 3603:'int64_t', 3604:'int64_t',
 3605:'int64_t', 3606:'int64_t', 3607:'int64_t', 3608:'int64_t', 3609:'int64_t',
 3610:'int64_t', 3611:'int64_t', 3612:'int64_t', 3613:'int64_t', 3614:'int64_t',
 3615:'int64_t', 3616:'int64_t', 3617:'int64_t', 3618:'int64_t', 3619:'int64_t',
 3620:'int64_t', 3621:'int64_t', 3622:'int64_t', 3623:'int64_t', 3624:'int64_t',
 3625:'int64_t', 3626:'int64_t', 3627:'int64_t', 3628:'int64_t', 3629:'int64_t',
 3630:'int64_t', 3631:'int64_t', 3632:'int64_t', 3633:'int64_t', 3634:'int64_t',
 3700:'char', 3701:'int', 3702:'char_list', 3703:'char_list',
 3704:'char_list', 3705:'char_list', 3706:'char_list', 3707:'int',
 3708:'char', 3709:'char_list', 3710:'int', 3711:'int', 
 3712:'LL_element', 3713:'LL_element', 3714:'char', 3715:'char',
 3716:'int64_t', 3717:'int64_t', 3718:'int64_t', 3719:'int64_t', 3720:'int64_t',
 3721:'int64_t', 3722:'int64_t', 3723:'int64_t', 3724:'int64_t', 3725:'int64_t',
 3726:'int64_t', 3727:'int64_t', 3728:'int64_t', 3729:'int64_t', 3730:'int64_t',
 3731:'int64_t', 3732:'int64_t', 3733:'int64_t', 3734:'int', 3735:'int',
 3736:'int', 3737:'int', 3738:'int', 3739:'int', 3740:'char', 
 3741:'char', 3742:'int'
 }

LLAPI_ENUMS = {
 "LL_JobManagementInteractiveClass":0, "LL_JobManagementListenSocket":1, "LL_JobManagementAccountNo":3,
 "LL_JobManagementSessionType":4, "LL_JobManagementPrinterFILE":5, "LL_JobManagementRestorePrinter":6,
 "LL_JobGetFirstStep":200, "LL_JobGetNextStep":201, "LL_JobCredential":202, "LL_JobName":203,
 "LL_JobStepCount":204, "LL_JobStepType":205, "LL_JobSubmitHost":206, "LL_JobSubmitTime":207,
 "LL_JobVersionNum":208, 
 "LL_StepNodeCount":400, "LL_StepGetFirstNode":401, "LL_StepGetNextNode":402, "LL_StepMachineCount":403,
 "LL_StepGetFirstMachine":404, "LL_StepGetNextMachine":405, "LL_StepGetFirstSwitchTable":406,
 "LL_StepGetNextSwitchTable":407, "LL_StepGetMasterTask":408, "LL_StepTaskInstanceCount":409,
 "LL_StepAccountNumber":410, "LL_StepAdapterUsage":411, "LL_StepComment":412,  "LL_StepCompletionCode":413,
 "LL_StepCompletionDate":414, "LL_StepEnvironment":415, "LL_StepErrorFile":416, "LL_StepExecSize":417,
 "LL_StepHostName":418, "LL_StepID":419, "LL_StepInputFile":420, "LL_StepImageSize":421, "LL_StepImmediate":422,
 "LL_StepIwd":423, "LL_StepJobClass":424, "LL_StepMessages":425, "LL_StepName":426, "LL_StepNodeUsage":427, 
 "LL_StepOutputFile":428, "LL_StepParallelMode":429, "LL_StepPriority":430, "LL_StepShell":431, 
 "LL_StepStartDate":432, "LL_StepDispatchTime":433, "LL_StepState":434, "LL_StepStartCount":435, 
 "LL_StepCpuLimitHard":436, "LL_StepCpuLimitSoft":437, "LL_StepCpuStepLimitHard":438, 
 "LL_StepCpuStepLimitSoft":439, "LL_StepCoreLimitHard":440, "LL_StepCoreLimitSoft":441, 
 "LL_StepDataLimitHard":442, "LL_StepDataLimitSoft":443, "LL_StepFileLimitHard":444,
 "LL_StepFileLimitSoft":445, "LL_StepRssLimitHard":446, "LL_StepRssLimitSoft":447, "LL_StepStackLimitHard":448,
 "LL_StepStackLimitSoft":449, "LL_StepWallClockLimitHard":450, "LL_StepWallClockLimitSoft":451,
 "LL_StepHostList":452, "LL_StepHoldType":453, "LL_StepLoadLevelerGroup":454, "LL_StepGetFirstAdapterReq":455,
 "LL_StepGetNextAdapterReq":456, "LL_StepRestart":457, "LL_StepBlocking":458, "LL_StepTaskGeometry":459,
 "LL_StepTotalTasksRequested":460, "LL_StepTasksPerNodeRequested":461, "LL_StepTotalNodesRequested":462,
 "LL_StepSystemPriority":463, "LL_StepClassSystemPriority":464, "LL_StepGroupSystemPriority":465, 
 "LL_StepUserSystemPriority":466, "LL_StepQueueSystemPriority":467, "LL_StepExecutionFactor":468,
 "LL_StepImageSize64":469, "LL_StepCpuLimitHard64":470, "LL_StepCpuLimitSoft64":471,
 "LL_StepCpuStepLimitHard64":472, "LL_StepCpuStepLimitSoft64":473, "LL_StepCoreLimitHard64":474,
 "LL_StepCoreLimitSoft64":475, "LL_StepDataLimitHard64":476, "LL_StepDataLimitSoft64":477,
 "LL_StepFileLimitHard64":478, "LL_StepFileLimitSoft64":479, "LL_StepRssLimitHard64":480,
 "LL_StepRssLimitSoft64":481, "LL_StepStackLimitHard64":482, "LL_StepStackLimitSoft64":483, 
 "LL_StepWallClockLimitHard64":484, "LL_StepWallClockLimitSoft64":485, "LL_StepStepUserTime64":486, 
 "LL_StepStepSystemTime64":487, "LL_StepStepMaxrss64":488, "LL_StepStepIxrss64":489, "LL_StepStepIdrss64":490,
 "LL_StepStepIsrss64":491, "LL_StepStepMinflt64":492, "LL_StepStepMajflt64":493, "LL_StepStepNswap64":494,
 "LL_StepStepInblock64":495, "LL_StepStepOublock64":496, "LL_StepStepMsgsnd64":497, "LL_StepStepMsgrcv64":498,
 "LL_StepStepNsignals64":499, "LL_StepStepNvcsw64":500, "LL_StepStepNivcsw64":501, "LL_StepStarterUserTime64":502,
 "LL_StepStarterSystemTime64":503, "LL_StepStarterMaxrss64":504, "LL_StepStarterIxrss64":505,
 "LL_StepStarterIdrss64":506, "LL_StepStarterIsrss64":507, "LL_StepStarterMinflt64":508, "LL_StepStarterMajflt64":509,
 "LL_StepStarterNswap64":510, "LL_StepStarterInblock64":511, "LL_StepStarterOublock64":512,
 "LL_StepStarterMsgsnd64":513, "LL_StepStarterMsgrcv64":514, "LL_StepStarterNsignals64":515,
 "LL_StepStarterNvcsw64":516, "LL_StepStarterNivcsw64":517, "LL_StepMachUsageCount":518,
 "LL_StepGetFirstMachUsage":519, "LL_StepGetNextMachUsage":520, "LL_StepCheckpointable":521,
 "LL_StepCheckpointing":522, "LL_StepCkptAccumTime":523, "LL_StepCkptFailStartTime":524,
 "LL_StepCkptFile":525, "LL_StepCkptGoodElapseTime":526, "LL_StepCkptGoodStartTime":527,
 "LL_StepCkptTimeHardLimit":528, "LL_StepCkptTimeHardLimit64":529, "LL_StepCkptTimeSoftLimit":530,
 "LL_StepCkptTimeSoftLimit64":531, "LL_StepCkptRestart":532, "LL_StepCkptRestartSameNodes":533,
 "LL_StepWallClockUsed":534, "LL_StepLargePage":535, "LL_StepMaxProtocolInstances":536,
 "LL_StepBulkXfer":537, "LL_StepTotalRcxtBlocks":538,"LL_StepStartTime":539,
 "LL_StepUserRcxtBlocks":540,
 "LL_MachineAdapterList":800, "LL_MachineArchitecture":801, "LL_MachineAvailableClassList":802,
 "LL_MachineCPUs":803, "LL_MachineDisk":804, "LL_MachineFeatureList":805, "LL_MachineConfiguredClassList":806,
 "LL_MachineKbddIdle":807, "LL_MachineLoadAverage":808, "LL_MachineMachineMode":809, "LL_MachineMaxTasks":810,
 "LL_MachineName":811, "LL_MachineOperatingSystem":812, "LL_MachinePoolList":813, "LL_MachineRealMemory":814,
 "LL_MachineScheddRunningJobs":815, "LL_MachineScheddState":816, "LL_MachineScheddTotalJobs":817,
 "LL_MachineSpeed":818, "LL_MachineStartdState":819, "LL_MachineStartdRunningJobs":820, "LL_MachineStepList":821,
 "LL_MachineTimeStamp":822, "LL_MachineVirtualMemory":823, "LL_MachinePoolListSize":824, 
 "LL_MachineFreeRealMemory":825, "LL_MachinePagesScanned":826, "LL_MachinePagesFreed":827,
 "LL_MachinePagesPagedIn":828, "LL_MachinePagesPagedOut":829, "LL_MachineGetFirstResource":830,
 "LL_MachineGetNextResource":831, "LL_MachineGetFirstAdapter":832, "LL_MachineGetNextAdapter":833,
 "LL_MachineDrainingClassList":834, "LL_MachineDrainClassList":835, "LL_MachineStartExpr":836,
 "LL_MachineSuspendExpr":837, "LL_MachineContinueExpr":838, "LL_MachineVacateExpr":839,
 "LL_MachineKillExpr":840, "LL_MachineDisk64":841, "LL_MachineRealMemory64":842,
 "LL_MachineVirtualMemory64":843, "LL_MachineFreeRealMemory64":844, "LL_MachinePagesScanned64":845,
 "LL_MachinePagesFreed64":846, "LL_MachinePagesPagedIn64":847, "LL_MachinePagesPagedOut64":848,
 "LL_MachineLargePageSize64":849, "LL_MachineLargePageCount64":850, "LL_MachineLargePageFree64":851,
 "LL_NodeTaskCount":1000, "LL_NodeGetFirstTask":1001, "LL_NodeGetNextTask":1002, "LL_NodeMaxInstances":1003,
 "LL_NodeMinInstances":1004, "LL_NodeRequirements":1005, "LL_NodeInitiatorCount":1006,
 "LL_SwitchTableJobKey":1200,
 "LL_TaskTaskInstanceCount":1400, "LL_TaskGetFirstTaskInstance":1401, "LL_TaskGetNextTaskInstance":1402,
 "LL_TaskExecutable":1403, "LL_TaskExecutableArguments":1404, "LL_TaskIsMaster":1405,
 "LL_TaskGetFirstResourceRequirement":1406, "LL_TaskGetNextResourceRequirement":1407,
 "LL_TaskInstanceAdapterCount":1600, "LL_TaskInstanceGetFirstAdapter":1601, "LL_TaskInstanceGetNextAdapter":1602,
 "LL_TaskInstanceGetFirstAdapterUsage":1603, "LL_TaskInstanceGetNextAdapterUsage":1604,
 "LL_TaskInstanceMachineName":1605, "LL_TaskInstanceTaskID":1606, "LL_TaskInstanceMachineAddress":1607,
 "LL_AdapterInterfaceAddress":1800, "LL_AdapterMode":1801, "LL_AdapterName":1802, "LL_AdapterUsageWindow":1803,
 "LL_AdapterUsageProtocol":1804, "LL_AdapterCommInterface":1806, "LL_AdapterUsageMode":1807,
 "LL_AdapterTotalWindowCount":1811, "LL_AdapterAvailWindowCount":1812, "LL_AdapterUsageAddress":1813,
 "LL_AdapterUsageCommunicationInterface":1814, "LL_AdapterUsageDevice":1815, "LL_AdapterUsageInstanceNumber":1816,
 "LL_AdapterUsageNetworkId":1817, "LL_AdapterWindowList":1818, "LL_AdapterUsageWindowMemory64":1819, 
 "LL_AdapterMinWindowSize64":1820, "LL_AdapterMaxWindowSize64":1821, "LL_AdapterMemory64":1822,
 "LL_AdapterUsageTag":1823,
 "LL_CredentialGid":2000, "LL_CredentialGroupName":2001, "LL_CredentialUid":2002, "LL_CredentialUserName":2003,
 "LL_StartdPerfJobsRunning":2200, "LL_StartdPerfJobsPending":2201, "LL_StartdPerfJobsSuspended":2202,
 "LL_StartdPerfCurrentJobs":2203, "LL_StartdPerfTotalJobsReceived":2204, "LL_StartdPerfTotalJobsCompleted":2205,
 "LL_StartdPerfTotalJobsRemoved":2206, "LL_StartdPerfTotalJobsVacated":2207, "LL_StartdPerfTotalJobsRejected":2208,
 "LL_StartdPerfTotalJobsSuspended":2209, "LL_StartdPerfTotalConnections":2210, "LL_StartdPerfFailedConnections":2211,
 "LL_StartdPerfTotalOutTransactions":2212, "LL_StartdPerfFailedOutTransactions":2213,
 "LL_StartdPerfTotalInTransactions":2214, "LL_StartdPerfFailedInTransactions":2215,
 "LL_ScheddPerfJobsIdle":2400, "LL_ScheddPerfJobsPending":2401, "LL_ScheddPerfJobsStarting":2402,
 "LL_ScheddPerfJobsRunning":2403, "LL_ScheddPerfCurrentJobs":2404, "LL_ScheddPerfTotalJobsSubmitted":2405,
 "LL_ScheddPerfTotalJobsCompleted":2406, "LL_ScheddPerfTotalJobsRemoved":2407, "LL_ScheddPerfTotalJobsVacated":2408,
 "LL_ScheddPerfTotalJobsRejected":2409, "LL_ScheddPerfTotalConnections":2410, "LL_ScheddPerfFailedConnections":2411,
 "LL_ScheddPerfTotalOutTransactions":2412, "LL_ScheddPerfFailedOutTransactions":2413,
 "LL_ScheddPerfTotalInTransactions":2414, "LL_ScheddPerfFailedInTransactions":2415,
 "LL_VersionCheck":2600,
 "LL_AdapterReqCommLevel":2700, "LL_AdapterReqUsage":2701,
 "LL_ClusterGetFirstResource":2800, "LL_ClusterGetNextResource":2801, "LL_ClusterSchedulingResources":2802,
 "LL_ClusterDefinedResources":2803, "LL_ClusterSchedulingResourceCount":2804, "LL_ClusterDefinedResourceCount":2805,
 "LL_ClusterEnforcedResources":2806, "LL_ClusterEnforcedResourceCount":2807, "LL_ClusterEnforceSubmission":2808,
 "LL_ClusterSchedulerType":2809,
 "LL_ResourceName":2900, "LL_ResourceInitialValue":2901, "LL_ResourceAvailableValue":2902,
 "LL_ResourceInitialValue64":2903, "LL_ResourceAvailableValue64":2904,
 "LL_ResourceRequirementName":3000, "LL_ResourceRequirementValue":3001, "LL_ResourceRequirementValue64":3002,
 "LL_WlmStatCpuTotalUsage":3100, "LL_WlmStatCpuSnapshotUsage":3101, "LL_WlmStatMemoryHighWater":3102,
 "LL_WlmStatMemorySnapshotUsage":3103,
 "LL_MatrixTimeSlice":3200, "LL_MatrixColumnCount":3201, "LL_MatrixRowCount":3202, "LL_MatrixGetFirstColumn":3203,
 "LL_MatrixGetNextColumn":3204,
 "LL_ColumnMachineName":3300, "LL_ColumnProcessorNumber":3301, "LL_ColumnRowCount":3302, "LL_ColumnStepNames":3303,
 "LL_MachUsageMachineName":3400, "LL_MachUsageMachineSpeed":3401, "LL_MachUsageDispUsageCount":3402,
 "LL_MachUsageGetFirstDispUsage":3403, "LL_MachUsageGetNextDispUsage":3404,
 "LL_DispUsageEventUsageCount":3500, "LL_DispUsageGetFirstEventUsage":3501, "LL_DispUsageGetNextEventUsage":3502,
 "LL_DispUsageStepUserTime64":3503, "LL_DispUsageStepSystemTime64":3504, "LL_DispUsageStepMaxrss64":3505,
 "LL_DispUsageStepIxrss64":3506, "LL_DispUsageStepIdrss64":3507, "LL_DispUsageStepIsrss64":3508,
 "LL_DispUsageStepMinflt64":3509, "LL_DispUsageStepMajflt64":3510, "LL_DispUsageStepNswap64":3511,
 "LL_DispUsageStepInblock64":3512, "LL_DispUsageStepOublock64":3513, "LL_DispUsageStepMsgsnd64":3514,
 "LL_DispUsageStepMsgrcv64":3515, "LL_DispUsageStepNsignals64":3516, "LL_DispUsageStepNvcsw64":3517,
 "LL_DispUsageStepNivcsw64":3518, "LL_DispUsageStarterUserTime64":3519, "LL_DispUsageStarterSystemTime64":3520,
 "LL_DispUsageStarterMaxrss64":3521, "LL_DispUsageStarterIxrss64":3522, "LL_DispUsageStarterIdrss64":3523,
 "LL_DispUsageStarterIsrss64":3524, "LL_DispUsageStarterMinflt64":3525, "LL_DispUsageStarterMajflt64":3526,
 "LL_DispUsageStarterNswap64":3527, "LL_DispUsageStarterInblock64":3528, "LL_DispUsageStarterOublock64":3529,
 "LL_DispUsageStarterMsgsnd64":3530, "LL_DispUsageStarterMsgrcv64":3531, "LL_DispUsageStarterNsignals64":3532,
 "LL_DispUsageStarterNvcsw64":3533, "LL_DispUsageStarterNivcsw64":3534,
 "LL_EventUsageEventID":3600, "LL_EventUsageEventName":3601, "LL_EventUsageEventTimestamp":3602,
 "LL_EventUsageStepUserTime64":3603, "LL_EventUsageStepSystemTime64":3604, "LL_EventUsageStepMaxrss64":3605,
 "LL_EventUsageStepIxrss64":3606, "LL_EventUsageStepIdrss64":3607, "LL_EventUsageStepIsrss64":3608,
 "LL_EventUsageStepMinflt64":3609, "LL_EventUsageStepMajflt64":3610, "LL_EventUsageStepNswap64":3611,
 "LL_EventUsageStepInblock64":3612, "LL_EventUsageStepOublock64":3613, "LL_EventUsageStepMsgsnd64":3614,
 "LL_EventUsageStepMsgrcv64":3615, "LL_EventUsageStepNsignals64":3616, "LL_EventUsageStepNvcsw64":3617,
 "LL_EventUsageStepNivcsw64":3618, "LL_EventUsageStarterUserTime64":3619, "LL_EventUsageStarterSystemTime64":3620,
 "LL_EventUsageStarterMaxrss64":3621, "LL_EventUsageStarterIxrss64":3622, "LL_EventUsageStarterIdrss64":3623,
 "LL_EventUsageStarterIsrss64":3624, "LL_EventUsageStarterMinflt64":3625, "LL_EventUsageStarterMajflt64":3626,
 "LL_EventUsageStarterNswap64":3627, "LL_EventUsageStarterInblock64":3628, "LL_EventUsageStarterOublock64":3629,
 "LL_EventUsageStarterMsgsnd64":3630, "LL_EventUsageStarterMsgrcv64":3631, "LL_EventUsageStarterNsignals64":3632,
 "LL_EventUsageStarterNvcsw64":3633, "LL_EventUsageStarterNivcsw64":3634,
 "LL_ClassName":3700, "LL_ClassPriority":3701, "LL_ClassExcludeUsers":3702, "LL_ClassIncludeUsers":3703,
 "LL_ClassExcludeGroups":3704, "LL_ClassIncludeGroups":3705, "LL_ClassAdmin":3706, "LL_ClassNqsClass":3707,
 "LL_ClassNqsSubmit":3708, "LL_ClassNqsQuery":3709, "LL_ClassMaxProcessors":3710, "LL_ClassMaxJobs":3711,
 "LL_ClassGetFirstResourceRequirement":3712, "LL_ClassGetNextResourceRequirement":3713,
 "LL_ClassComment":3714, "LL_ClassCkptDir":3715, "LL_ClassCkptTimeHardLimit":3716,
 "LL_ClassCkptTimeSoftLimit":3717, "LL_ClassWallClockLimitHard":3718, "LL_ClassWallClockLimitSoft":3719,
 "LL_ClassCpuStepLimitHard":3720, "LL_ClassCpuStepLimitSoft":3721, "LL_ClassCpuLimitHard":3722,
 "LL_ClassCpuLimitSoft":3723, "LL_ClassDataLimitHard":3724, "LL_ClassDataLimitSoft":3725,
 "LL_ClassCoreLimitHard":3726, "LL_ClassCoreLimitSoft":3727, "LL_ClassFileLimitHard":3728,
 "LL_ClassFileLimitSoft":3729, "LL_ClassStackLimitHard":3730, "LL_ClassStackLimitSoft":3731,
 "LL_ClassRssLimitHard":3732, "LL_ClassRssLimitSoft":3733, "LL_ClassNice":3734, "LL_ClassFreeSlots":3735,
 "LL_ClassMaximumSlots":3736, "LL_ClassConstraints":3737, "LL_ClassExecutionFactor":3738,
 "LL_ClassMaxTotalTasks":3739, "LL_ClassPreemptClass":3740, "LL_ClassStartClass":3741,
 "LL_ClassMaxProtocolInstances":3742}

#
# Create variables from the dictionary entries in LLAPI_ENUMS
#

for k,v in LLAPI_ENUMS.iteritems():
    exec("%s=%d" % (k,v) )
